/*
 * test_bklpreempt.c
 *
 * Copyright 2009. Quantum Corporation. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it would be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write the Free Software Foundation,
 * Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "bklpreempt.h"



#define TRANSLATE_CMDSTRING(arg, i, x)		\
    if (!strncmp(arg, #x, 20)) {	\
      i = x; \
    }

void usage(void)
{
    printf ("DUMP_WAITQUEUE: %d\n", DUMP_WAITQUEUE);
    printf ("START_SLEEPER: %d\n", START_SLEEPER);
    printf ("WAKEUP_SLEEPER: %d\n", WAKEUP_SLEEPER);
}


int main(int argc, char **argv)
{
    int fd;
    int cmd = 0;
    int retried = 0;

    fd = open("/dev/bklbug", O_RDWR);

    if (argc == 1) {
	fprintf (stderr, "Invalid command:\n");
	usage();
	return 1;
    }

    cmd = atoi(argv[1]);

retry:

    if (cmd >= DUMP_WAITQUEUE && cmd <= WAKEUP_SLEEPER) {
	ioctl(fd, cmd);
    } else {
	if (!retried) {
	    /* this should allow the scripts to use a command string
	     * instead of number, in case the definition of _IO is
	     * different for some reason */
	    TRANSLATE_CMDSTRING(argv[1], cmd, DUMP_WAITQUEUE);
	    TRANSLATE_CMDSTRING(argv[1], cmd, START_SLEEPER);
	    TRANSLATE_CMDSTRING(argv[1], cmd, WAKEUP_SLEEPER);
	    goto retry;
	} else {
	    fprintf (stderr, "Invalid command:\n");
	    usage();
	    return 1;
	}
    }

    return 0;

}
